package ejb;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

@Stateless
@TransactionManagement(TransactionManagementType.CONTAINER)
public class JMSJCATestBedBean implements JMSJCATestBedLocal {

        @Resource(name = "jms/EnterpriseApplicationJMSJCAQueue")
        private Destination enterpriseApplicationJMSJCAQueue;

	@Resource(name = "jms/EnterpriseApplicationJMSJCAConnectionFactory")
	private ConnectionFactory enterpriseApplicationJMSJCAConnectionFactory;

	private Message createJMSMessageForjmsTestQueue(Session session, Object messageData) throws JMSException {
		// TODO create and populate message to send
		TextMessage tm = session.createTextMessage();
		tm.setText(messageData.toString());
		return tm;
	}

    public void doCase(int option)  {

        if (option==1){
            caseOne();
        } else {
            throw new UnsupportedOperationException("Option "+option+" not supported yet.");
        }

    }

    public void caseOne() {
        try {
            Connection connection1 = enterpriseApplicationJMSJCAConnectionFactory.createConnection();
            Session session1 = connection1.createSession(false, Session.AUTO_ACKNOWLEDGE);

            MessageProducer messageProducer = session1.createProducer(enterpriseApplicationJMSJCAQueue);
            messageProducer.send(createJMSMessageForjmsTestQueue(session1, "Hello"));

            connection1.close();

        } catch (JMSException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
        }
    }
}
